/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/


//#include "typedefine.h"
#include <machine.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mathf.h>
#include <complex.h>
#include "sound_effector.h"
#include "sci.h"


#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

void main(void)
{

	unsigned long prev_inbuf_wp;
	
	int i;
	
	pcm_data pcm_tmp;
	
	float out_ch0, out_ch1;		//CC-RXł́Adbl_size=8 w肵ȂꍇAfloat^double^͓i4oCgj
	
	float volume1_val, volume2_val;
	
	char xc;
	
	pcm_data input_max, input_min;
	
	pcm_data max_val, min_val;
	
	unsigned short max_min_print_flag = 0;
	unsigned short max_min_print_counter = 0;
	
	max_val.ch0 = 32767;
	max_val.ch1 = 32767;
	
	min_val.ch0 = -32768;
	min_val.ch1 = -32768;
	
	//֐
	sound_effector_init();
	
	PORTE.PDR.BIT.B2 = 1;
	PORTE.PDR.BIT.B1 = 1;
	
	sciInit();		//SCI
	
	sciPrint("\n");
	sciPrint("Copyright (C) 2019 HokutoDenshi. All Rights Reserved.\n");
	sciPrint("-Sound Effector debug console-\n");
	sciPrint("debug MENU:\n");
	sciPrint("  i: Input device value print\n");
	sciPrint("  p: Input level Max-Min print(every 5sec), toggle\n");
	sciPrint("\n");
	sciPrint(">");
	
	//Jn
	sound_effector_start();
	
	prev_inbuf_wp = 0;

	while(1)
	{
		xc = sciRead();
		
		switch(xc)
		{
			case 'i':
				sciPrintBuf("i\n");
				sciPrintBuf("input: Push-SW->");
				sciPrintByteBuf(g_sw_state);
				sciPrintBuf(", Volume(");
				sciPrintShortIntBuf(g_ad_val[0]);
				sciPrintBuf(",");
				sciPrintShortIntBuf(g_ad_val[1]);
				sciPrintBuf(",");
				sciPrintShortIntBuf(g_ad_val[2]);
				sciPrintBuf(")\n");
				sciPrintBuf("\n>");
				break;
			
			case 'p':
				sciPrintBuf("p\n");
				if(max_min_print_flag == 0)
				{
					sciPrintBuf("print-max-min: toggle ON\n");
					max_min_print_flag = 1;
					input_max = min_val;
					input_min = max_val;
					max_min_print_counter = 0;
				}
				else
				{
					sciPrintBuf("print-max-min: toggle OFF\n");
					sciPrintBuf("\n>");
					max_min_print_flag = 0;
				}
				break;
		}
		
		if(g_sw_state == 0)
		{
			//X[
			if(prev_inbuf_wp != g_inbuf_wp)
			{
#ifdef DEBUG_PORT
				P27 = 1;										//SCI1gpP26́ATXD1ƂĎgp̂Ń|[gfobOƂĂ͎gpłȂ->P27gp
#endif
				if(max_min_print_flag == 1)
				{		
					if(max_min_print_counter >= 1000)
					{
						
						sciPrintBuf("max-min:\n");
						sciPrintBuf("  ch0: (");
						sciPrintShortSignedIntBuf(input_max.ch0);
						sciPrintBuf(" - ");
						sciPrintShortSignedIntBuf(input_min.ch0);
						sciPrintBuf(")\n");
						sciPrintBuf("  ch1: (");
						sciPrintShortSignedIntBuf(input_max.ch1);
						sciPrintBuf(" - ");
						sciPrintShortSignedIntBuf(input_min.ch1);
						sciPrintBuf(")\n");
					
						input_max = min_val;
						input_min = max_val;
						max_min_print_counter = 0;
					}
					max_min_print_counter++;
				}

				for(i=0; i<INBUF_UNIT_SIZE; i++)
				{
					if(max_min_print_flag == 1)
					{
						if(input_max.ch0 < g_inbuf[prev_inbuf_wp + i].ch0) input_max.ch0 = g_inbuf[prev_inbuf_wp + i].ch0;
						if(input_max.ch1 < g_inbuf[prev_inbuf_wp + i].ch1) input_max.ch1 = g_inbuf[prev_inbuf_wp + i].ch1;
						if(input_min.ch0 > g_inbuf[prev_inbuf_wp + i].ch0) input_min.ch0 = g_inbuf[prev_inbuf_wp + i].ch0;
						if(input_min.ch1 > g_inbuf[prev_inbuf_wp + i].ch1) input_min.ch1 = g_inbuf[prev_inbuf_wp + i].ch1;
					}
					
					put_data(g_inbuf[prev_inbuf_wp + i]);		//̓obt@̒l𖢉Hŏo̓obt@Ɋi[
				}
				prev_inbuf_wp = g_inbuf_wp;						//̓obt@̃|C^lۑ

#ifdef DEBUG_PORT
				P27 = 1;
#endif

#ifdef DEBUG
				g_err_led_patturn = LED_OFF;
#endif
			}
		}
		else
		{
			//{[
			if(prev_inbuf_wp != g_inbuf_wp)	//f[^ INBUF_UNIT_SIZE ܂
			{
#ifdef DEBUG_PORT
				P27 = 1;
#endif
				
				if(max_min_print_flag == 1)
				{		
					if(max_min_print_counter >= 1000)
					{
						
						sciPrintBuf("max-min:\n");
						sciPrintBuf("  ch0: (");
						sciPrintShortSignedIntBuf(input_max.ch0);
						sciPrintBuf(" - ");
						sciPrintShortSignedIntBuf(input_min.ch0);
						sciPrintBuf(")\n");
						sciPrintBuf("  ch1: (");
						sciPrintShortSignedIntBuf(input_max.ch1);
						sciPrintBuf(" - ");
						sciPrintShortSignedIntBuf(input_min.ch1);
						sciPrintBuf(")\n");
					
						input_max = min_val;
						input_min = max_val;
						max_min_print_counter = 0;
					}
					max_min_print_counter++;
				}
				
				//{[lǂݎ
				volume1_val = (float)g_ad_val[0] / 4096.0;		//{[l𐳋K(0 ` 1)
				volume2_val = (float)g_ad_val[1] / 4096.0;
				
				for(i=0; i<INBUF_UNIT_SIZE; i++)
				{
					if(max_min_print_flag == 1)
					{
						if(input_max.ch0 < g_inbuf[prev_inbuf_wp + i].ch0) input_max.ch0 = g_inbuf[prev_inbuf_wp + i].ch0;
						if(input_max.ch1 < g_inbuf[prev_inbuf_wp + i].ch1) input_max.ch1 = g_inbuf[prev_inbuf_wp + i].ch1;
						if(input_min.ch0 > g_inbuf[prev_inbuf_wp + i].ch0) input_min.ch0 = g_inbuf[prev_inbuf_wp + i].ch0;
						if(input_min.ch1 > g_inbuf[prev_inbuf_wp + i].ch1) input_min.ch1 = g_inbuf[prev_inbuf_wp + i].ch1;
					}
						
					out_ch0 = (float)g_inbuf[prev_inbuf_wp + i].ch0 / 32768.0; 	//͒l𐳋K(-1 ` 1)
					out_ch1 = (float)g_inbuf[prev_inbuf_wp + i].ch1 / 32768.0;
					
					out_ch0 *= volume1_val;			//{[lZ
					out_ch1 *= volume2_val;
					
					//NbsO
					pcm_tmp = clipping_data_norm(out_ch0, out_ch1);
					
					//o̓obt@Ɋi[
					put_data(pcm_tmp);
				}

				prev_inbuf_wp = g_inbuf_wp;
				
#ifdef DEBUG_PORT
				P27 = 1;
#endif

#ifdef DEBUG
				g_err_led_patturn = 0x00000001;
#endif
			}
		}
	}//while
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
